#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <queue>
#include <cassert>
#include <algorithm>
#include <stack>
#include <set>
#include <cstdio>

// testlib is evil
#define stderr stdout

#include "testlib.h"

using namespace std;

struct Control {
    int a, b, len;
    vector<Control*> c;
    static int idx;

    Control() {
        a = inf.readInt();
        b = inf.readInt();
        int nc = inf.readInt();
        for (int i = 0; i < nc; ++i)
          c.push_back(new Control());
    }

    int Check() {
        ++idx;
        len = ouf.readInt();
        if (len == -1)
          CheckImpossible();
        quitif(len < a, _wa, "Control %d too short: %d < %d", idx, len, a);
        quitif(len > b, _wa, "Control %d too long: %d > %d", idx, len, b);
        int total_length = 0, idx1 = idx;
        for (int i = 0; i < c.size(); ++i)
            total_length += c[i]->Check();
        quitif(c.size() > 0 && total_length != len, _wa,
            "Control %d children length: %d instead of %d", idx1, total_length, len);
        return len;
    }

    static void CheckImpossible() {
        quitif(Control::idx > 1, _pe, "Unexpected -1 at pos: %d", idx);
        quitif(ans.readInt() != -1, _wa, "Solution not found");
        quitf(_ok, "ok");
    }
};

int Control::idx = 0;

int main(int argc, char** argv) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    Control *root = new Control();
    root->Check();
    quitif(Control::idx != n, _pe, "Control count: %d instead of %d", Control::idx, n);
    quitif(ans.readInt() == -1, _fail, "Unexpected solution");
    quitf(_ok, "ok");
}
