{$mode objfpc}{$assertions on}{$r+}{$h+}
uses Math;

type
  TControl = class
  public
    FA, FB: Integer;
    FAq, FBq: Integer;
    FL: Integer;
    FC: array of TControl;
    constructor Read;
    procedure CalcAB;
    procedure RequestLen(len: Integer);
    procedure PrintL;
    function CountR: Integer;
  end;

constructor TControl.Read;
var
  i, nc: Integer;
begin
  System.Read(FA, FB, nc);
  Assert((1 <= FA) and (FA <= FB) and (FB <= 1000000) and (nc >= 0));
  SetLength(FC, nc);
  for i := 0 to High(FC) do FC[i] := TControl.Read;
end;

procedure TControl.CalcAB;
var
  c: TControl;
begin
  if FC = nil then begin
    FAq := FA;
    FBq := FB;
    exit;
  end;
  for c in FC do begin
    c.CalcAB;
    FAq += c.FAq;
    FBq += c.FBq;
  end;
  FAq := Max(FA, FAq);
  FBq := Min(FB, FBq);
  if FAq > FBq then begin
    Write(-1);
    Halt;
  end;
end;

procedure TControl.RequestLen(len: Integer);
var
  c: TControl;
  extra: Integer;
begin
  Assert(InRange(len, FAq, FBq));
  FL := len;
  if FC = nil then exit;
  extra := len;
  for c in FC do
    extra -= c.FAq;
  for c in FC do begin
    c.RequestLen(Min(c.FAq + extra, c.FBq));
    extra -= c.FL - c.FAq;
  end;
  Assert(extra = 0);
end;

function TControl.CountR: Integer;
var
  c: TControl;
begin
  Result := 1;
  for c in FC do Result += c.CountR;
end;

procedure TControl.PrintL;
var
  c: TControl;
begin
  Writeln(FL);
  for c in FC do
    c.PrintL;
end;

var
  root: TControl;
  N: Integer;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(N);
  root := TControl.Read;
  Assert(root.CountR = N);
  root.CalcAB;
  root.RequestLen(root.FAq);
  root.PrintL;
end.
